VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "DirectDraw-Animation in PictureBox"
   ClientHeight    =   2280
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4245
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2280
   ScaleWidth      =   4245
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.PictureBox Picture2 
      BackColor       =   &H80000007&
      BorderStyle     =   0  'Kein
      Height          =   1815
      Left            =   240
      ScaleHeight     =   1815
      ScaleWidth      =   1815
      TabIndex        =   3
      Top             =   240
      Width           =   1815
      Begin VB.PictureBox Picture1 
         BorderStyle     =   0  'Kein
         Height          =   1695
         Left            =   130
         ScaleHeight     =   113
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   105
         TabIndex        =   4
         Top             =   90
         Width           =   1575
      End
   End
   Begin VB.CommandButton cmd_Beenden 
      Caption         =   "&Beenden"
      Height          =   495
      Left            =   2280
      TabIndex        =   2
      Top             =   1560
      Width           =   1695
   End
   Begin VB.CommandButton cmd_Stop 
      Caption         =   "Animation st&oppen"
      Enabled         =   0   'False
      Height          =   495
      Left            =   2280
      TabIndex        =   1
      Top             =   900
      Width           =   1695
   End
   Begin VB.CommandButton cmd_Start 
      Caption         =   "Animation st&arten"
      Height          =   495
      Left            =   2280
      TabIndex        =   0
      Top             =   240
      Width           =   1695
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.vb-fun.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source-Code !

Option Explicit

'=== DirectDraw-Initialisations-Variablen ===
Dim DX7 As New DirectX7
Dim DD7 As DirectDraw7
Dim SurfaceDesc As DDSURFACEDESC2
Dim PrimarySurface As DirectDrawSurface7
Dim BackBuffer As DirectDrawSurface7
Dim ddClipper As DirectDrawClipper
Dim bmpBild1 As DirectDrawSurface7
Dim AniCount As Single
Dim AniRunning As Boolean

Dim r1 As RECT
Dim r2 As RECT

Dim running As Boolean
Dim FrameTime As Long

Private Sub Form_Load()
    Dim srcrect As RECT
    Dim Aniline As Integer

    Me.Show
    Me.Refresh
    
    Initialization   'DirectDraw initialisieren
    BitmapLaden
    
    running = True
    
    Do

        FrameTime = GetTime
        
        'Feststellen wie gro die PictureBox ist...
        'denn nur in dieses Rechteck sollte gezeichnet werden
        DX7.GetWindowRect Picture1.hWnd, r1

        BackBuffer.BltColorFill r2, 0
        
        'Festlegen welchen Bereich vom Bitmap wir kopieren
        'mchten ... in diesem Fall nur jeweils eine Kugel
        Aniline = AniCount \ 9
        With srcrect
            .Left = 101 * (AniCount - (Aniline * 9)): .Right = .Left + 101
            .Top = 102 * Aniline: .Bottom = .Top + 102
        End With
        'Bitmap in den Backbuffer zeichnen
        BackBuffer.BltFast 0, 0, bmpBild1, srcrect, DDBLTFAST_WAIT
        
        If AniRunning Then
            AniCount = AniCount + 1
            If AniCount > 43 Then AniCount = 0
        End If
        
        With r2
            .Left = 0: .Right = Picture1.ScaleWidth
            .Top = 0: .Bottom = Picture1.ScaleHeight
        End With
        PrimarySurface.Blt r1, BackBuffer, r2, DDBLT_WAIT
        
        DoEvents
        
        Do Until GetTime - FrameTime > 40
        Loop
    
    Loop While running
    
    Terminate
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Terminate
End Sub

Sub Initialization()
    
    'Holen wir uns den Zugriff auf das DirectDraw-Objekt.
    'Der leere String-Parameter bedeutet,
    'dass der aktive Bildschirmtreiber benutzt werden soll
    Set DD7 = DX7.DirectDrawCreate("")
    'Die Anwendung soll im Fenster laufen
    DD7.SetCooperativeLevel Me.hWnd, DDSCL_NORMAL
    'Beschreibung des PrimarySurface --> ohne einem BackBuffer !
    With SurfaceDesc
        .lFlags = DDSD_CAPS
        .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE
    End With
    'PrimarySurface initialisieren auf dem alles abgebildet wird
    Set PrimarySurface = DD7.CreateSurface(SurfaceDesc)

    'Beschreibung des BackBuffer
    With SurfaceDesc
        .lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
        .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
        .lHeight = Picture1.ScaleHeight
        .lWidth = Picture1.ScaleWidth
    End With
    'BackBuffer initialisieren auf dem gezeichnet wird
    Set BackBuffer = DD7.CreateSurface(SurfaceDesc)
    
    'Clipper initialisieren fr den Bereich in dem wir zeichnen drfen
    Set ddClipper = DD7.CreateClipper(0)
    'Clipper auf die PictureBox setzen
    ddClipper.SetHWnd Picture1.hWnd
    'und auf unsere PrimarySurface
    PrimarySurface.SetClipper ddClipper
    
End Sub

Sub BitmapLaden()
    Dim BmpDesc As DDSURFACEDESC2
        
    BmpDesc.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
    BmpDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    
    BmpDesc.lWidth = 909
    BmpDesc.lHeight = 510
    
    Set bmpBild1 = DD7.CreateSurfaceFromFile(App.Path & "\vbfun.bmp", BmpDesc)
    
End Sub

Sub Terminate()
    Set bmpBild1 = Nothing
    Set ddClipper = Nothing
    Set BackBuffer = Nothing
    Set PrimarySurface = Nothing
    'alte Auflsung wiederherstellen
    DD7.RestoreDisplayMode
    DD7.SetCooperativeLevel Me.hWnd, DDSCL_NORMAL
    End
End Sub

Function GetTime() As Long
    GetTime = DX7.TickCount
End Function

Private Sub Form_KeyPress(KeyAscii As Integer)
    If (KeyAscii = vbKeyEscape) Then
        running = False
    End If
End Sub

Private Sub cmd_Start_Click()
    AniRunning = True
    cmd_Stop.Enabled = cmd_Stop.Enabled Xor -1
    cmd_Start.Enabled = cmd_Start.Enabled Xor -1
End Sub

Private Sub cmd_Stop_Click()
    AniRunning = False
    cmd_Start.Enabled = cmd_Start.Enabled Xor -1
    cmd_Stop.Enabled = cmd_Stop.Enabled Xor -1
End Sub

Private Sub cmd_Beenden_Click()
    running = False
End Sub


